#include <sys/stat.h>

#include "http/res.h"

void http_res_set_body_buf(http_response *res, const char *body,
                           size_t body_len, bool owned) {
  res->body.type = http_body_buf;
  res->body.buf = (char *)body;
  res->body.expected_len = body_len;
  res->body.buf_owned = owned;
}

void http_res_set_body_file(http_response *res, const char *filename) {
  struct stat st;
  stat(filename, &st);

  // TODO error handling
  FILE *f = fopen(filename, "r");

  res->body.type = http_body_file;
  res->body.file = f;
  res->body.expected_len = st.st_size;
}

void http_res_add_header(http_response *res, http_header type,
                         const char *value, bool owned) {
  res->headers[res->header_count].type = type;
  res->headers[res->header_count].value = value;
  res->headers[res->header_count].owned = owned;

  res->header_count++;
}

void http_res_set_mime_type(http_response *res, http_mime_type mime_type) {
  http_res_add_header(res, http_header_content_type,
                      http_mime_type_names[mime_type][1], false);
}
